#include <iostream> // for using cout
#include <fstream>  // for using streams
#include <vector>   // for using vectors
#include <list>     // for using lists
#include "student.h"

#define MAX_LINE 256

vector<CStudent*>std_vector; // Declaration of vector
vector<CStudent*>std_vector_sorted;

CStudent::CStudent()
{
  name_first = "Max";
  name_last = "Mustermann";
  course = "Acting";
  year = 2007;
  bmp_id = -1;
  home_work_I = 0;
  home_work_II = 0;
  credit = 0;
  birthday = "01.01.1980";
  nation = "one-world-is-enough-for-all-of-us";
  gender = "male/female (you never know)";
  id = -1;
  email = "xyz@xyz.eu";
  operation_system = "Windows";
}

CStudent::~CStudent()
{
}

CStudentAEG::CStudentAEG()
{
  course = "AEG";
}

long CStudent::GetBankAccount()
{
	return bank_account;
}

void CStudent::SetBankAccount(long lvalue)
{
	bank_account=lvalue;
}

void CStudent::Print(ostream &o_file)
{
  o_file << "===============" << endl;
  o_file << name_first << endl;
  o_file << name_last << endl;
  o_file << course << endl;
  o_file << id << endl;
  o_file << "===============" << endl<<endl;
}

void CStudent::Write(ostream &o_file)
{
  o_file << "#STUDENT" << endl;
  o_file << " $NAME_LAST" << endl;
  o_file << name_last << endl;
  o_file << " $NAME_FIRST" << endl;
  o_file << name_first << endl;
  o_file << " $COURSE" << endl;
  o_file << course << endl;
  o_file << " $ID" << endl;
  o_file << id << endl;
  o_file << " $BIRTHDAY" << endl;
  o_file << birthday << endl;
  o_file << " $NATION" << endl;
  o_file << nation << endl;
  o_file << " $GENDER" << endl;
  o_file << gender << endl;
  o_file << " $EMAIL" << endl;
  o_file << email << endl;
  o_file << " $FOTO_ID" << endl;
  o_file << bmp_id << endl;
  o_file << endl;
}

/**************************************************************************
STDLib-Method: 
Sort STD objects alphabetically
07/2009 OK Implementation
**************************************************************************/
void STDSort()
{
  //----------------------------------------------------------------
  int i;
  CStudent* m_std = NULL;
  list<string>name_list;
  for(i=0;i<(int)std_vector.size();i++)
  {
    m_std = std_vector[i];
    name_list.push_back(m_std->name_last);
    //name_list.push_back(m_std->name_first);
  }
  //----------------------------------------------------------------
  name_list.sort();
  //----------------------------------------------------------------
  // 
  int pos = 0;
  list<string>::const_iterator iterator;
  iterator = name_list.begin();
  string name_last;
  while(iterator != name_list.end()) 
  {
    name_last = *iterator;
    for(i=0;i<(int)std_vector.size();i++)
    {
      m_std = std_vector[i];
      if(m_std->name_last.compare(name_last)==0)
      {
        std_vector_sorted.push_back(m_std);
      }
    }
    ++iterator;
    pos++;
  }
  //----------------------------------------------------------------
  for(i=0;i<(int)std_vector_sorted.size();i++)
  {
    cout << std_vector_sorted[i]->name_last << endl;
  }
  std_vector.clear();
  for(int i=0;i<(int)std_vector_sorted.size();i++)
  {
    std_vector.push_back(std_vector_sorted[i]);
  }
  std_vector_sorted.clear();
}

/**************************************************************************
STDLib-Method:
Task: Reading all STD objects
06/2009 OK Implementation
**************************************************************************/
bool STDRead(ifstream& std_file)
{
  //----------------------------------------------------------------------
  char line[MAX_LINE];
  string line_string;
  ios::pos_type position;
  CStudent* m_std = NULL;
  //----------------------------------------------------------------------
//OK  STDDelete();
  //----------------------------------------------------------------------
  // rewind the file
  std_file.seekg(0,ios::beg);
  //----------------------------------------------------------------------
  // OBJ reading
  cout << "STDRead:" << endl;
  while(!std_file.eof())
  {
    m_std = new CStudent();
    //    position = m_std->Read(std_file); // from E63
    m_std->Read(std_file); // from E63
    std_vector.push_back(m_std);
  } // eof
  //----------------------------------------------------------------------
  cout << "Number of data sets: " << std_vector.size() << endl;
  return true;
}

/**************************************************************************
STD read function
04/2009 OK Implementation
**************************************************************************/
//ios::pos_type CStudent::Read(ifstream& input_file)
void CStudent::Read(ifstream& input_file)
{
  //----------------------------------------------------------------------
  string input_line;
  char buffer[MAX_LINE];
  ios::pos_type position;
  //----------------------------------------------------------------------
  while(true)
  {
    input_file.getline(buffer,MAX_LINE);
    input_line = buffer;
    if(input_line.size()<1) // empty line
      continue;
    // Dealing with keywords
    if(input_line.find('#')!=string::npos) // keyword found
      return;
    // Dealing with subkeywords
    if(input_line.find("$NAME_FIRST")!=string::npos) // lesen bis ans Ende des strings
    {
      input_file >> name_first;
    }
    if(input_line.find("$NAME_LAST")!=string::npos)
    {
      input_file >> name_last;
    }
    if(input_line.find("$COURSE")!=string::npos)
    {
      input_file >> course;
    }
    if(input_line.find("$YEAR")!=string::npos)
    {
      input_file >> year;
    }
    if(input_line.find("$BANK_ACCOUNT")!=string::npos)
    {
      input_file >> bank_account;
    }
    if(input_line.find("$BIRTHDAY")!=string::npos)
    {
      input_file >> birthday;
    }
    if(input_line.find("$NATION")!=string::npos)
    {
      input_file >> nation;
    }
    if(input_line.find("$GENDER")!=string::npos)
    {
      input_file >> gender;
    }
    if(input_line.find("$ID")!=string::npos)
    {
      input_file >> id;
    }
    if(input_line.find("$EMAIL")!=string::npos)
    {
      input_file >> email;
    }
    if(input_line.find("$ADDRESS")!=string::npos)
    {
      input_file >> city;
      input_file >> street;
    }
    if(input_line.find("$FOTO_ID")!=string::npos)
    {
      input_file >> bmp_id;
    }
  }
  //----------------------------------------------------------------------
  return;
}
